Compare commits

...

16 Commits
24.05 ... main

10 changed files with 557 additions and 26 deletions

View File

@ -1,5 +1,5 @@
SUBDIRS := $(wildcard */.)
VERSION = 24.05
VERSION = 24.09
install:
@for dir in $(SUBDIRS) ; do \

View File

@ -9,10 +9,12 @@ Following dependencies are required for these scripts and tools:
- bash
- coreutils
- make
- grep
- GRUB (please see matter-iso warning)
- gnupg
- fakeroot
- (GNU) tar
- (GNU) cpio
- [matt](https://git.matterlinux.xyz/Matter/matt)
After installing these dependencies, all the tools and scripts
@ -30,4 +32,5 @@ All tools/scripts contains usage information in README files:
- [matter-base](matter-base/README.md)
- [matter-iso](matter-iso/README.md)
- [mp-build](mp-build/README.md)
- [mp-check](mp-check/README.md)
- [mp-pool](mp-pool/README.md)

View File

@ -80,6 +80,7 @@ if ! type "grub-mkrescue" > /dev/null; then
set_indent
warn "If you want to create UEFI ISO files make sure you install x64 GRUB or grub-efi"
warn "If you want to create BIOS ISO files make sure you install x86 GRUB or grub-bios"
warn "After installing GRUB, don't forget to install libisoburn as well"
exit 1
fi
@ -199,7 +200,7 @@ rm "${tmpdir}/stager.sh"
info "Cleaning up and building initrd"
rm "${isoh}"
pushd "$TMPDIR" > /dev/null
pushd "${tmpdir}" > /dev/null
mkdir -p "${rootdir}/boot"
find . | cpio --quiet -H newc -o | xz -T0 --check=crc32 > "${rootdir}/boot/initrd.img"
check_ret "Failed to build initrd"

View File

@ -42,7 +42,11 @@ get_fn_url() {
get_file() {
if [[ "${1}" == "https://"* || "${1}" == "http://"* || "${1}" == "ftp://"* ]]
then
curl "${1}" --progress-bar -OL
if [ $OPT_INSECURE -eq 1 ]; then
curl "${1}" --insecure --progress-bar -OL
else
curl "${1}" --progress-bar -OL
fi
return $?
elif [ -f "${pkgpath}/${1}" ]; then
cp "${pkgpath}/${1}" .
@ -89,6 +93,7 @@ help_cmd() {
echo_color " $BOLD--no-depend$RESET: don't check depends"
echo_color " $BOLD--no-stdout$RESET: disable stdout for PACKAGE() function"
echo_color " $BOLD--no-cache$RESET: don't check cache"
echo_color " $BOLD--insecure$RESET: allow insecure curl downloads"
echo_color " $BOLD--no-opts$RESET: don't show/list options"
echo_color " $BOLD--cores$RESET: how many cores to use for the build"
echo_color " $BOLD--out$RESET: directory for the output archive"
@ -105,7 +110,7 @@ clean_dist() {
rm -f "${distpath}/files.tar.gz"
}
# install a list of packages with matt
# install a list of packages with matt
matt_install(){
if [ "$EUID" -ne 0 ]; then
if type doas > /dev/null; then
@ -117,7 +122,7 @@ matt_install(){
return 1
fi
fi
$DOAS matt install --yes --skip --ignore-none $@
return $?
}
@ -154,6 +159,7 @@ check_depends() {
OPT_NO_DEPEND=0 # checking depends is ENABLED
OPT_NO_STDOUT=0 # PACKAGE() function output is ENABLED
OPT_NO_CACHE=0 # cache is ENABLED
OPT_INSECURE=0 # insecure curl downloads are DISABLED
OPT_NO_OPTS=0 # showing/listing options is ENABLED
OPT_CORES=$(nproc) # use ALL CPU cores
OPT_OUT="DEFAULT" # use the package dist directory for output
@ -171,6 +177,8 @@ for arg in "$@"; do
OPT_NO_STDOUT=1 ;;
"--no-cache")
OPT_NO_CACHE=1 ;;
"--insecure")
OPT_INSECURE=1 ;;
"--no-opts")
OPT_NO_OPTS=1 ;;
"--cores"*)
@ -223,6 +231,7 @@ if [ $OPT_NO_OPTS -eq 0 ]; then
print " $BOLD NO_DEPEND = $(itoyn $OPT_NO_DEPEND)"
print " $BOLD NO_SDTOUT = $(itoyn $OPT_NO_STDOUT)"
print " $BOLD NO_CACHE = $(itoyn $OPT_NO_CACHE)"
print " $BOLD INSECURE = $(itoyn $OPT_INSECURE)"
print " $BOLD NO_OPTS = $(itoyn $OPT_NO_OPTS)"
print " $BOLD CORES = ${OPT_CORES}"
print " $BOLD OUT = ${OPT_OUT}"
@ -368,6 +377,8 @@ info "Running the build function"
export CC="gcc"
export CXX="g++"
export CFLAGS="-march=x86-64 -mtune=generic -O2"
export CPPFLAGS="-march=x86-64 -mtune=generic -O2"
export CXXFLAGS="-march=x86-64 -mtune=generic -O2"
export ROOTDIR="${rootpath}"
export MAKEFLAGS="-j${OPT_CORES}"
export MAKEOPTS="-j${OPT_CORES}"
@ -387,6 +398,7 @@ fi
unset XORG_CONFIG XORG_PREFIX
unset MAKEOPTS MAKEFLAGS CXX
unset CPPFLAGS CXXFLAGS
unset CFLAGS ROOTDIR CC
if [ "$SECONDS" != "0" ]; then
@ -409,6 +421,11 @@ mkdir -p "${distpath}"
clean_dist
# build the files archive
if [ -z "$(ls -A)" ]; then
error "Root directory is empty, did something went wrong during build?"
exit 1
fi
find . -printf "%P\n" | fakeroot tar -czf "${distpath}/files.tar.gz" --no-recursion -T -
check_ret "(1/6) Failed to create the files archive (files.tar.gz)"
success "(1/6) Created the files archive (files.tar.gz)"
@ -438,7 +455,7 @@ success "(3/6) Created the changes file (CHANGES)"
# create the install script
if type INSTALL &>/dev/null; then
echo "$(type INSTALL | head -n-1 | tail -n-2 | sed 's/ //')" > "${distpath}/INSTALL"
echo "$(type INSTALL | head -n-1 | sed '1,3d' | sed 's/ //')" > "${distpath}/INSTALL"
check_ret "(4/6) Failed to create the install script (INSTALL)"
fi
success "(4/6) Created the install script (INSTALL)"

9
mp-check/Makefile Normal file
View File

@ -0,0 +1,9 @@
PREFIX = /usr
install:
install -Dm755 "main.sh" $(DESTDIR)/$(PREFIX)/bin/mp-check
uninstall:
rm $(DESTDIR)/$(PREFIX)/bin/mp-check
.PHONY: install uninstall

15
mp-check/README.md Normal file
View File

@ -0,0 +1,15 @@
# mp-check | MatterLinux package check script
A simple script to check MatterLinux package archives and sources
for common errors and mistakes.
### Usage
To check a package archive, specify the path for the archive:
script:
```bash
mp-check /path/to/package_version.mpf
```
You can also check for package sources files by specifying the
path for the package source directory:
```bash
mp-check /path/to/package/source
```

458
mp-check/main.sh Executable file
View File

@ -0,0 +1,458 @@
#!/bin/bash
# mp-check | MatterLinux package check script
# MatterLinux 2023-2024 (https://matterlinux.xyz)
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <https://www.gnu.org/licenses/>.
#############################
## import common functions ##
#############################
location=$(dirname "${0}")
location=$(realpath "${location}")
commonsh="$(echo "${location}" | sed 's/\/bin/\/lib/g')/mtsc-common.sh"
source "${commonsh}" > /dev/null
if [ "${?}" != "0" ]; then
echo "Failed to import mtsc-common"
exit 1
fi
#################
## global vars ##
#################
warnc=0
tmpdir="/tmp/.mp-check"
required_files=(
"DATA"
"HASHES"
"CHANGES"
"files.tar.gz"
)
required_keys=(
"version"
"desc"
"size"
)
root_dirs=(
"boot"
"etc"
"mnt"
"srv"
"usr"
"var"
"opt"
"run"
)
bad_vars=(
'$VERSION'
'$ROOTDIR'
'$NAME'
'$DESC'
)
####################
## util functions ##
####################
# prints the help info
help_cmd() {
info "MatterLinux package check script (mtsc ${MTSC_VERSION})" # sourced from mtsc-common
info "Usage: ${0} <options> [archive file/source dir]"
info "Options:"
echo_color " $BOLD--checkpoint$RESET: specify a starting point for the check"
echo_color " $BOLD--fail-warn$RESET: fail on a warning"
echo_color " $BOLD--no-warn$RESET: ignore warnings"
echo
info "Licensed under GPLv3, see <https://www.gnu.org/licenses/> for more information"
}
# adds a new warning to the counter
add_warning(){
[ $OPT_NO_WARN -eq 1 ] && return
warn "${1}"
warnc=$((warnc+1))
[ $OPT_FAIL_WARN -eq 1 ] && fail_check
}
# cleans up the temp directoru
clean_tempdir(){
rm -rf "${tmpdir}"
}
# recreates the temp directory
make_tempdir(){
clean_tempdir
mkdir "${tmpdir}"
}
# returns check status fail
fail_check(){
clean_tempdir
unset_indent
error "${BOLD}Check ${RED}FAILED${RESET}"
exit 1
}
# returns check status fail
success_check(){
clean_tempdir
unset_indent
if [ "${warnc}" == "0" ]; then
success "Check ${GREEN}SUCCESS${RESET}"
elif [ "${warnc}" == "1" ]; then
success "Check ${GREEN}SUCCESS${RESET}${BOLD} with ${YELLOW}${warnc}${RESET}${BOLD} warning${RESET}"
else
success "Check ${GREEN}SUCCESS${RESET}${BOLD} with ${YELLOW}${warnc}${RESET}${BOLD} warnings${RESET}"
fi
exit 0
}
# if the last command failed, print error and fail
check_ret_fail(){
if [ $? -ne 0 ]; then
if [ ! -z "$1" ]; then
error "$1"
fi
fail_check
fi
}
check_archive(){
make_tempdir
info "Extracting the archive"
tar xf "${archivepath}" -C "${tmpdir}"
check_ret_fail "Failed to extract the archive"
info "Checking archive files"
for f in "${required_files[@]}"; do
if [ ! -f "${tmpdir}/${f}" ]; then
error "Archive does not contain required file: ${BOLD}${f}${RESET}"
fail_check
fi
done
info "Checking DATA file"
for k in "${required_keys[@]}"; do
local line_1="$(grep "^${k}=" "${tmpdir}/DATA")"
local line_2="$(grep "^${k} =" "${tmpdir}/DATA")"
if [ -z "${line_1}" ] && [ -z "${line_2}" ]; then
error "File does not contain the required key: ${BOLD}${k}${RESET}"
fail_check
fi
if [ "${k}" == "version" ]; then
if [ ! -z "${line_1}" ]; then
version="$(echo "${line_1}" | sed 's/version= //g')"
version="$(echo "${version}" | sed 's/version=//g')"
else
version="$(echo "${line_2}" | sed 's/version = //g')"
version="$(echo "${version}" | sed 's/version =//g')"
fi
if [ -z "${version}" ]; then
error "Failed to obtain package version information"
fail_check
fi
fi
if [ "${k}" == "size" ]; then
if [ ! -z "${line_1}" ]; then
size="$(echo "${line_1}" | sed 's/size= //g')"
size="$(echo "${size}" | sed 's/size=//g')"
else
size="$(echo "${line_2}" | sed 's/size = //g')"
size="$(echo "${size}" | sed 's/size =//g')"
fi
if [ -z "${size}" ]; then
error "Failed to obtain package size information"
fail_check
fi
if [ "${size}" == "0" ]; then
error "Package size information is set as 0, is the package empty?"
fail_check
fi
fi
done
name="$(head -n1 "${tmpdir}/DATA" | sed 's/\[//g')"
name="$(echo "${name}" | sed 's/]//g')"
if [ -z "${name}" ]; then
error "Failed to obtain package name information"
fail_check
fi
case "${name}" in
*_*)
error "Package name contains an invalid character: \"_\""
fail_check ;;
*" "*)
error "Package name contains an invalid character: \" \""
fail_check ;;
esac
case "${version}" in
*_*)
error "Package version contains an invalid character: \"_\""
fail_check ;;
*" "*)
error "Package version contains an invalid character: \" \""
fail_check ;;
esac
filename="${name}_${version}.mpf"
info "Checking HASHES file"
while read l; do
if [ -z "${l}" ]; then
continue
fi
local hash_line="$(echo "${l}" | cut -d' ' -f1)"
local file_line="$(echo "${l}" | cut -d' ' -f3)"
if [ -z "${hash_line}" ] || [ -z "${file_line}" ]; then
error "File contains an invalid formatted line"
fail_check
fi
if [ "${#hash_line}" != "32" ]; then
error "File contains an invalid MD5 hash"
fail_check
fi
done < "${tmpdir}/HASHES"
info "Checking files.tar.gz archive"
filec=0
while read p; do
if [ -z "${p}" ]; then
continue
fi
filec=$((filec + 1))
if [ "${p:0:1}" == "." ] || [ "${p:0:1}" == "/" ]; then
error "Root file location is invalid (${p:0:1})"
fail_check
fi
local path_root="$(echo "${p}" | cut -d/ -f1)"
local found=0
for d in "${root_dirs[@]}"; do
if [ "${path_root}" == "${d}" ]; then
found=1
break
fi
done
if [ "${found}" == "0" ]; then
error "Package files contains an unknown root directory: ${path_root}"
fail_check
fi
done < <(tar tf "${tmpdir}/files.tar.gz")
if [ "${filec}" == "0" ]; then
error "Package file archive is empty (no files)"
fail_check
fi
info "Checking INSTALL file"
if [ -f "${tmpdir}/INSTALL" ] && ! grep -q . "${tmpdir}/INSTALL"; then
add_warning "Package contains an empty install script"
fi
info "Checking CHANGES file"
if ! grep -q . "${tmpdir}/CHANGES"; then
add_warning "Changes file is empty"
fi
if ! grep "${version}" "${tmpdir}/CHANGES" &> /dev/null; then
add_warning "Changes potentially does not have an entry for the current version"
fi
info "Checking archive name"
archivefile="$(basename "${archivepath}")"
if [ "${archivefile}" != "${filename}" ]; then
add_warning "Package archive name is not ideal (${archivefile} -> ${filename})"
fi
clean_tempdir
}
check_source(){
info "Checking the package script"
if [ ! -f "${sourcepath}/pkg.sh" ]; then
error "Package script does not exist"
fail_check
fi
source "${sourcepath}/pkg.sh"
check_ret_fail "Failed to source the package script"
check_pkg_vars
check_ret_fail
if [ ${#DESC} -gt 200 ]; then
error "Package description is too long (>200)"
fail_check
fi
local desc_lower="${DESC,,}"
local line_num=0
if [[ "${DESC}" == *"contains"* ]] || [[ "${DESC}" == *"provides"* ]]; then
add_warning "Avoid using words such as \"contains\" or \"provides\" in the package description"
fi
if type INSTALL &>/dev/null; then
for v in "${bad_vars[@]}"; do
if type INSTALL | grep "${v}" &> /dev/null; then
error "${v} used in the install script"
fail_check
fi
done
fi
while read l; do
line_num=$((line_num+1))
for v in "${bad_vars[@]}"; do
if echo "${l}" | grep "${v}" &> /dev/null; then
add_warning "${v} used without parenthesis on line ${line_num}"
fi
done
if echo "${l}" | grep '&&' | grep -v 'cd ..' &> /dev/null; then
add_warning "Unreliable use of \"&&\" on line ${line_num}"
fi
done < "${sourcepath}/pkg.sh"
info "Checking the changes file"
if [ ! -f "${sourcepath}/changes.md" ]; then
error "Package does not contain a changes file"
fail_check
fi
if ! grep -q . "${sourcepath}/changes.md"; then
add_warning "Changes file is empty"
fi
if ! grep "${VERSION}" "${sourcepath}/changes.md" &> /dev/null; then
add_warning "Changes potentially does not have an entry for the current version"
fi
clean_pkg_vars
}
#################
## main script ##
#################
OPT_CHECKPOINT=""
OPT_FAIL_WARN=0
OPT_NO_WARN=0
OPT_TARGET=()
for arg in "$@"; do
case $arg in
"--help")
help_cmd
exit 0 ;;
"--checkpoint"*)
OPT_CHECKPOINT="$(echo "${arg}" | cut -d '=' -f2)" ;;
"--fail-warn")
OPT_FAIL_WARN=1 ;;
"--no-warn")
OPT_NO_WARN=1 ;;
--*)
error "Unknown option: ${arg}"
exit 1 ;;
*)
OPT_TARGET+=("${arg}") ;;
esac
done
if [ -z "${OPT_TARGET}" ]; then
error "Please specify at least one package archive or a source directory, run --help for more info"
exit 1
fi
if [ $OPT_FAIL_WARN -eq 1 ] && [ $OPT_NO_WARN -eq 1 ]; then
error "Cannot use both of the --fail-warn and --no-warn options"
exit 1
fi
info "Running mp-check with the options:"
if [ -z "${OPT_CHECKPOINT}" ]; then
print " $BOLD CHECKPOINT = NONE"
else
print " $BOLD CHECKPOINT = ${OPT_CHECKPOINT}"
fi
print " $BOLD FAIL_WARN = $(itoyn $OPT_FAIL_WARN)"
print " $BOLD NO_WARN = $(itoyn $OPT_NO_WARN)"
for target in "${OPT_TARGET[@]}"; do
if [ ! -f "${target}" ] && [ ! -d "${target}" ]; then
error "Specified path is invalid: ${target}"
exit 1
fi
done
tc="${#OPT_TARGET[@]}"
got_checkpoint=0
ti=0
for target in "${OPT_TARGET[@]}"; do
unset_indent
ti=$((ti + 1))
if [ -z "${OPT_CHECKPOINT}" ] || [ "${target}" == "${OPT_CHECKPOINT}" ]; then
got_checkpoint=1
fi
[ $got_checkpoint -eq 0 ] && continue
if [ -f "${target}" ]; then
info "(${ti}/${tc}) Checking the archive: ${target}"
set_indent
archivepath="$(realpath "${target}")"
check_archive
elif [ -d "${target}" ]; then
info "(${ti}/${tc}) Checking the source directory: ${target}"
set_indent
sourcepath="$(realpath "${target}")"
check_source
fi
done
success_check

View File

@ -75,29 +75,35 @@ if [ ! -d "${distpath}" ]; then
exit 1
fi
# source and store every package
# source and store every package
files=("INFO" "LIST")
pc="$(ls -1q "${srcpath}" | wc -l)"
pi=1
pi=0
info "Sourcing all the packages"
set_indent
for pkg in "${srcpath}/"*; do
package=$(basename "${pkg}")
info "(${pi}/${pc}) Sourcing \"${package}\""
pkg_name=$(basename "${pkg}")
pi=$((pi+1))
if should_ignore "${pkg_name}"; then
info "(${pi}/${pc}) Ignoring \"${pkg_name}\""
continue
fi
info "(${pi}/${pc}) Sourcing \"${pkg_name}\""
source "${pkg}/pkg.sh"
check_ret "(${pi}/${pc}) Failed to import the source script for \"${package}\""
check_ret "(${pi}/${pc}) Failed to import the source script for \"${pkg_name}\""
check_pkg_vars
check_ret
files+=("${NAME}_${VERSION}.mpf")
files+=("${NAME}_${VERSION}.mpf.sig")
clean_pkg_vars
pi=$((pi+1))
done
success "Completed"

View File

@ -42,6 +42,7 @@ help_cmd() {
echo_color " $BOLD--no-depend$RESET: don't check depends"
echo_color " $BOLD--no-stdout$RESET: disable stdout for build() function"
echo_color " $BOLD--no-cache$RESET: don't use cache"
echo_color " $BOLD--insecure$RESET: allow insecure curl downloads"
echo_color " $BOLD--no-opts$RESET: don't show/list options"
echo_color " $BOLD--no-sign$RESET: don't sign build packages"
echo_color " $BOLD--cores$RESET: how many cores to use for the build"
@ -74,17 +75,10 @@ list_to_str(){
mp_build_opts(){
local opts=("${1}" "--no-opts" "--out='${2}'")
if [ $OPT_NO_DEPEND -eq 1 ]; then
opts+=("--no-depend")
fi
if [ $OPT_NO_STDOUT -eq 1 ]; then
opts+=("--no-stdout")
fi
if [ $OPT_NO_CACHE -eq 1 ]; then
opts+=("--no-cache")
fi
[ $OPT_NO_DEPEND -eq 1 ] && opts+=("--no-depend")
[ $OPT_NO_STDOUT -eq 1 ] && opts+=("--no-stdout")
[ $OPT_INSECURE -eq 1 ] && opts+=("--insecure")
[ $OPT_NO_CACHE -eq 1 ] && opts+=("--no-cache")
mp-build ${opts[@]}
return "$?"
@ -97,6 +91,7 @@ OPT_SKIP_FAIL=0 # stop build when a package build fails
OPT_NO_DEPEND=0 # checking depends is ENABLED
OPT_NO_STDOUT=0 # build() function output is ENABLED
OPT_NO_CACHE=0 # cache is ENABLED
OPT_INSECURE=0 # insecure curl downloads are DISABLED
OPT_NO_OPTS=0 # showing/listing options is ENABLED
OPT_NO_SIGN=0 # sign all the built packages
OPT_CORES=$(nproc) # use ALL CPU cores
@ -118,6 +113,8 @@ for arg in "$@"; do
OPT_NO_STDOUT=1 ;;
"--no-cache")
OPT_NO_CACHE=1 ;;
"--insecure")
OPT_INSECURE=1 ;;
"--no-opts")
OPT_NO_OPTS=1 ;;
"--no-sign")
@ -162,6 +159,7 @@ if [ $OPT_NO_OPTS -eq 0 ]; then
print " $BOLD NO_DEPEND = $(itoyn $OPT_NO_DEPEND)"
print " $BOLD NO_SDTOUT = $(itoyn $OPT_NO_STDOUT)"
print " $BOLD NO_CACHE = $(itoyn $OPT_NO_CACHE)"
print " $BOLD INSECURE = $(itoyn $OPT_INSECURE)"
print " $BOLD NO_OPTS = $(itoyn $OPT_NO_OPTS)"
print " $BOLD NO_SIGN = $(itoyn $OPT_NO_SIGN)"
print " $BOLD CORES = $OPT_CORES"
@ -205,16 +203,22 @@ fi
# build every package
pc=${#OPT_PACKAGES[@]}
pi=1
pi=0
for pkg_name in "${OPT_PACKAGES[@]}"; do
pkg="${srcpath}/${pkg_name}"
pi=$((pi+1))
if [ ! -d "${pkg}" ]; then
error "Package not found: \"${pkg_name}\""
exit 1
fi
if should_ignore "${pkg_name}"; then
info "(${pi}/${pc}) Ignoring \"${pkg_name}\""
continue
fi
info "(${pi}/${pc}) Building \"${pkg_name}\""
if [ $OPT_SKIP_FAIL -eq 1 ]; then
@ -239,7 +243,6 @@ for pkg_name in "${OPT_PACKAGES[@]}"; do
fi
success "(${pi}/${pc}) Build was successful for \"${pkg_name}\""
pi=$((pi+1))
done
success "Completed all the package builds"

View File

@ -228,5 +228,24 @@ check_pkg_vars() {
return 1 ;;
esac
case "${VERSION}" in
*_*)
error "Package version contains an invalid character: \"_\""
unset_indent
return 1 ;;
*" "*)
error "Package version contains an invalid character: \" \""
unset_indent
return 1 ;;
esac
return 0
}
# check if a package should be ignored
should_ignore(){
for i in "${IGNORE[@]}"; do
[ "${i}" == "${1}" ] && return 0
done
return 1
}